{-
File: TempConvert.hs

Purpose: Terminal-based program to convert Fahrenheit to Celsius

Compile at a terminal prompt with ghc --make TempConvert.hs

Run at terminal prompt with ./TempConvert

-}
    
-- main function launches when the application launches

module Main (main) where

import Conversions (fahrToCelsius)
import TerminalIO (getFloat, getString)

main :: IO ()
main = do
    degreesF <- getFloat "Enter the degrees Fahrenheit: "
    let degreesC = fahrToCelsius degreesF
    putStr "The degrees Celsius is "
    putStrLn (show degreesC)


{-

Iterative interaction: repeat until user presses return.

main :: IO ()
main = do
    degreesF <- getString "Enter the degrees Fahrenheit or return to quit: "
    if degreesF == "" then
        return ()
    else do
        let degreesC = fahrToCelsius (read degreesF :: Float)
        putStr "The degrees Celsius is "
        putStrLn (show degreesC)
        main
    
-}